/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2020 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "stdio.h"
#include "string.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
I2C_HandleTypeDef hi2c1;
I2C_HandleTypeDef hi2c2;

SPI_HandleTypeDef hspi1;

TIM_HandleTypeDef htim17;

UART_HandleTypeDef huart1;
UART_HandleTypeDef huart2;
UART_HandleTypeDef huart3;
UART_HandleTypeDef huart4;

/* USER CODE BEGIN PV */

void Init_Value(void);
uint8_t CountWrite(uint32_t tcount);
uint32_t PowerOn_CountRead(void);
uint32_t CountRead(void);

void DISP_LCD_RESET(void);
void DISP_LCD_SET_CGRAM(void);
void DISP_LCD_POS(uint8_t x, uint8_t y);
void DISP_LCD_CLEAR(uint8_t line);
void DISP_LCD_VERSION(void);
void DISP_LCD_INPUT(uint8_t lidx);
void DISP_LCD_OUTPUT(uint8_t lidx);

//=============================================================================================
//=============================================================================================

uint8_t SWON_SET(void);
uint8_t SWON_SHIFT(void);
uint8_t SWON_UP(void);
uint8_t SWON_DOWN(void);

uint8_t SWON_LEFT(void);
uint8_t SWON_RIGHT(void);
uint8_t SWON_EMG(void);

void Start_DelayTimer(uint16_t dtime);
void Start_ManuTimer(uint16_t dtime);
void Start_LcdTimer(uint16_t dtime);
void Reset_Rcv1Timer(uint8_t dtime);
void Reset_Rcv2Timer(uint8_t dtime);
void Reset_Rcv3Timer(uint8_t dtime);
void TimerCheck(void);
void InputCheck(void);
void Upload_Output(void);


void LeftLamp_Start(uint8_t idx,uint16_t ontime,uint16_t offtime);
void RightLamp_Start(uint8_t idx,uint16_t ontime,uint16_t offtime);
void EmgLamp_Start(uint8_t idx,uint16_t ontime,uint16_t offtime);
void LampBlinkCheck(void);

void ResetBeepValue(void);
void Beep_Once(void);
void Beep_Pass(void);
void Beep_Fail(void);
void Beep_Emergency(void);
void BeepControl(void);

void RCV_WORK(void);
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_TIM17_Init(void);
static void MX_USART1_UART_Init(void);
static void MX_USART4_UART_Init(void);
static void MX_USART2_UART_Init(void);
static void MX_USART3_UART_Init(void);
static void MX_I2C2_Init(void);
static void MX_I2C1_Init(void);
static void MX_SPI1_Init(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */
  

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */



  Init_Value();


  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  U3.Mode=idx_uart3_baud_115200;

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_TIM17_Init();
  MX_USART1_UART_Init();
  MX_USART4_UART_Init();
  MX_USART2_UART_Init();
  MX_USART3_UART_Init();
  MX_I2C2_Init();
  MX_I2C1_Init();
  MX_SPI1_Init();
  /* USER CODE BEGIN 2 */

  ResetBeepValue();

  HAL_Delay(10);

  SysTick_Config(64000);  // 64000  =  1ms interrupts
  HAL_TIM_Base_Start_IT(&htim17);
  HAL_UART_Receive_IT(&huart1, (uint8_t*)U1.RcvTemp, 1);
  HAL_UART_Receive_IT(&huart2, (uint8_t*)U2.RcvTemp, 1);
  HAL_UART_Receive_IT(&huart3, (uint8_t*)U3.RcvTemp, 1);


  HAL_Delay(500);

  DISP_LCD_VERSION();
  DISP_LCD_SET_CGRAM();
  LCD.BlktmrVlu=500;

  //--------------------------------------
  Start_DelayTimer(500);
  while(1){
	if(T_DELAY.tov){
		break;
	}
  }
  //--------------------------------------


  /* USER CODE END 2 */
 
 

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */


  MANU.Idx=0;
  MANU.Stat = 0;
  U1.Rcv_Flag=0;
  U3.Xycv_Rcv_Flag=0;

  Reset_LcdBlink(500);

  RESET_XYCV_DATA();


  while (1)
  {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */

	    DISP_GENERAL();

	  	RCV_WORK();
		XYCONV_WORK();


		switch(MAIN.Idx){

			case 0:
				MAIN.Idx = 10;
				//Start_DelayTimer(100);
				Start_DelayTimer(200);
				break;

			case 10:
				if(U1.Rcv_Flag){
					MAIN.Idx = 15;
				}
				else if(U3.Xycv_Rcv_Flag){
					MAIN.Idx = 20;
				}
				if(T_DELAY.tov){
					MAIN.Idx = 25;
				}
				break;


			case 15:
				U1.Rcv_Flag = 0;
				U3.strnum = sprintf(U3.TxString,"%s",U1.RxString);
				if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
				Start_DelayTimer(5);
				MAIN.Idx++;
				break;
			case 16:
				if(T_DELAY.tov){
					MAIN.Idx = 0;
				}
				break;


			case 20:
				U3.Xycv_Rcv_Flag=0;
				U1.strnum = sprintf(U1.TxString,"%s%c%c",U3.RxString,CHAR_CR,CHAR_LF);
				if(HAL_OK==HAL_UART_Transmit(&huart1,U1.TxString,(uint16_t)U1.strnum,(uint32_t)100)){}
				Start_DelayTimer(5);
				MAIN.Idx++;
				break;
			case 21:
				if(T_DELAY.tov){
					MAIN.Idx = 0;
				}
				break;


			case 25:
				Send_XYCV_STAq();
				Start_DelayTimer(1000);
				MAIN.Idx++;
				break;
			case 26:
				if(T_DELAY.tov){
					MAIN.Idx = 0;
				}
				if(U3.Xycv_Rcv_Flag){
					U3.Xycv_Rcv_Flag=0;
					uint8_t i,j,k;
					for(i = 0 , j = 0, k = 0 ; i < 16 ; i++ , j++ , k++){
						LCD.Line1[j] = U3.RxString[k];
					}
					for(i = 0 , j = 0 ; i < 16 ; i++ , j++ , k++){
						if(U3.RxString[k] == 0){
							LCD.Line2[j] = ' ';
						}
						else{
							LCD.Line2[j] = U3.RxString[k];
						}
					}
					MAIN.Idx = 0;
				}
				break;


			default:
				MAIN.Idx = 0;
				break;
		}

  }





  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};
  RCC_PeriphCLKInitTypeDef PeriphClkInit = {0};

  /** Configure the main internal regulator output voltage 
  */
  HAL_PWREx_ControlVoltageScaling(PWR_REGULATOR_VOLTAGE_SCALE1);
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = RCC_PLLM_DIV1;
  RCC_OscInitStruct.PLL.PLLN = 16;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLR = RCC_PLLR_DIV2;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the peripherals clocks 
  */
  PeriphClkInit.PeriphClockSelection = RCC_PERIPHCLK_USART1|RCC_PERIPHCLK_USART2
                              |RCC_PERIPHCLK_I2C1;
  PeriphClkInit.Usart1ClockSelection = RCC_USART1CLKSOURCE_PCLK1;
  PeriphClkInit.Usart2ClockSelection = RCC_USART2CLKSOURCE_PCLK1;
  PeriphClkInit.I2c1ClockSelection = RCC_I2C1CLKSOURCE_PCLK1;
  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInit) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief I2C1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_I2C1_Init(void)
{

  /* USER CODE BEGIN I2C1_Init 0 */

  /* USER CODE END I2C1_Init 0 */

  /* USER CODE BEGIN I2C1_Init 1 */

  /* USER CODE END I2C1_Init 1 */
  hi2c1.Instance = I2C1;
  hi2c1.Init.Timing = 0x10707DBC;
  hi2c1.Init.OwnAddress1 = 0;
  hi2c1.Init.AddressingMode = I2C_ADDRESSINGMODE_7BIT;
  hi2c1.Init.DualAddressMode = I2C_DUALADDRESS_DISABLE;
  hi2c1.Init.OwnAddress2 = 0;
  hi2c1.Init.OwnAddress2Masks = I2C_OA2_NOMASK;
  hi2c1.Init.GeneralCallMode = I2C_GENERALCALL_DISABLE;
  hi2c1.Init.NoStretchMode = I2C_NOSTRETCH_DISABLE;
  if (HAL_I2C_Init(&hi2c1) != HAL_OK)
  {
    Error_Handler();
  }
  /** Configure Analogue filter 
  */
  if (HAL_I2CEx_ConfigAnalogFilter(&hi2c1, I2C_ANALOGFILTER_ENABLE) != HAL_OK)
  {
    Error_Handler();
  }
  /** Configure Digital filter 
  */
  if (HAL_I2CEx_ConfigDigitalFilter(&hi2c1, 0) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN I2C1_Init 2 */

  /* USER CODE END I2C1_Init 2 */

}

/**
  * @brief I2C2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_I2C2_Init(void)
{

  /* USER CODE BEGIN I2C2_Init 0 */

  /* USER CODE END I2C2_Init 0 */

  /* USER CODE BEGIN I2C2_Init 1 */

  /* USER CODE END I2C2_Init 1 */
  hi2c2.Instance = I2C2;
  hi2c2.Init.Timing = 0x10707DBC;
  hi2c2.Init.OwnAddress1 = 0;
  hi2c2.Init.AddressingMode = I2C_ADDRESSINGMODE_7BIT;
  hi2c2.Init.DualAddressMode = I2C_DUALADDRESS_DISABLE;
  hi2c2.Init.OwnAddress2 = 0;
  hi2c2.Init.OwnAddress2Masks = I2C_OA2_NOMASK;
  hi2c2.Init.GeneralCallMode = I2C_GENERALCALL_DISABLE;
  hi2c2.Init.NoStretchMode = I2C_NOSTRETCH_DISABLE;
  if (HAL_I2C_Init(&hi2c2) != HAL_OK)
  {
    Error_Handler();
  }
  /** Configure Analogue filter 
  */
  if (HAL_I2CEx_ConfigAnalogFilter(&hi2c2, I2C_ANALOGFILTER_ENABLE) != HAL_OK)
  {
    Error_Handler();
  }
  /** Configure Digital filter 
  */
  if (HAL_I2CEx_ConfigDigitalFilter(&hi2c2, 0) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN I2C2_Init 2 */

  /* USER CODE END I2C2_Init 2 */

}

/**
  * @brief SPI1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_SPI1_Init(void)
{

  /* USER CODE BEGIN SPI1_Init 0 */

  /* USER CODE END SPI1_Init 0 */

  /* USER CODE BEGIN SPI1_Init 1 */

if(SPI_1.Mode==idx_SpiMode_Master){

  /* USER CODE END SPI1_Init 1 */
  /* SPI1 parameter configuration*/
  hspi1.Instance = SPI1;
  hspi1.Init.Mode = SPI_MODE_MASTER;
  hspi1.Init.Direction = SPI_DIRECTION_2LINES;
  hspi1.Init.DataSize = SPI_DATASIZE_8BIT;
  hspi1.Init.CLKPolarity = SPI_POLARITY_LOW;
  hspi1.Init.CLKPhase = SPI_PHASE_1EDGE;
  hspi1.Init.NSS = SPI_NSS_HARD_OUTPUT;
  hspi1.Init.BaudRatePrescaler = SPI_BAUDRATEPRESCALER_64;
  hspi1.Init.FirstBit = SPI_FIRSTBIT_MSB;
  hspi1.Init.TIMode = SPI_TIMODE_DISABLE;
  hspi1.Init.CRCCalculation = SPI_CRCCALCULATION_DISABLE;
  hspi1.Init.CRCPolynomial = 7;
  hspi1.Init.CRCLength = SPI_CRC_LENGTH_DATASIZE;
  hspi1.Init.NSSPMode = SPI_NSS_PULSE_ENABLE;
  if (HAL_SPI_Init(&hspi1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN SPI1_Init 2 */

}
  else if(SPI_1.Mode==idx_SpiMode_Slave){

  	hspi1.Instance = SPI1;
    hspi1.Init.Mode = SPI_MODE_SLAVE;
    hspi1.Init.Direction = SPI_DIRECTION_2LINES;
    hspi1.Init.DataSize = SPI_DATASIZE_8BIT;
    hspi1.Init.CLKPolarity = SPI_POLARITY_LOW;
    hspi1.Init.CLKPhase = SPI_PHASE_1EDGE;
    hspi1.Init.NSS = SPI_NSS_HARD_INPUT;
    hspi1.Init.FirstBit = SPI_FIRSTBIT_MSB;
    hspi1.Init.TIMode = SPI_TIMODE_DISABLE;
    hspi1.Init.CRCCalculation = SPI_CRCCALCULATION_DISABLE;
    hspi1.Init.CRCPolynomial = 7;
    hspi1.Init.CRCLength = SPI_CRC_LENGTH_DATASIZE;
    hspi1.Init.NSSPMode = SPI_NSS_PULSE_DISABLE;
    if (HAL_SPI_Init(&hspi1) != HAL_OK)
    {
      Error_Handler();
    }

  }



  /* USER CODE END SPI1_Init 2 */

}

/**
  * @brief TIM17 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM17_Init(void)
{

  /* USER CODE BEGIN TIM17_Init 0 */

  /* USER CODE END TIM17_Init 0 */

  /* USER CODE BEGIN TIM17_Init 1 */

  /* USER CODE END TIM17_Init 1 */
  htim17.Instance = TIM17;
  htim17.Init.Prescaler = 64000;
  htim17.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim17.Init.Period = 1000;
  htim17.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  htim17.Init.RepetitionCounter = 0;
  htim17.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_ENABLE;
  if (HAL_TIM_Base_Init(&htim17) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM17_Init 2 */

  /* USER CODE END TIM17_Init 2 */

}

/**
  * @brief USART1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART1_UART_Init(void)
{

  /* USER CODE BEGIN USART1_Init 0 */

  /* USER CODE END USART1_Init 0 */

  /* USER CODE BEGIN USART1_Init 1 */

  /* USER CODE END USART1_Init 1 */
  huart1.Instance = USART1;
  huart1.Init.BaudRate = 115200;
  huart1.Init.WordLength = UART_WORDLENGTH_8B;
  huart1.Init.StopBits = UART_STOPBITS_1;
  huart1.Init.Parity = UART_PARITY_NONE;
  huart1.Init.Mode = UART_MODE_TX_RX;
  huart1.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart1.Init.OverSampling = UART_OVERSAMPLING_16;
  huart1.Init.OneBitSampling = UART_ONE_BIT_SAMPLE_DISABLE;
  huart1.Init.ClockPrescaler = UART_PRESCALER_DIV1;
  huart1.AdvancedInit.AdvFeatureInit = UART_ADVFEATURE_NO_INIT;
  if (HAL_UART_Init(&huart1) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_UARTEx_SetTxFifoThreshold(&huart1, UART_TXFIFO_THRESHOLD_1_8) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_UARTEx_SetRxFifoThreshold(&huart1, UART_RXFIFO_THRESHOLD_1_8) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_UARTEx_DisableFifoMode(&huart1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART1_Init 2 */

  /* USER CODE END USART1_Init 2 */

}

/**
  * @brief USART2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART2_UART_Init(void)
{

  /* USER CODE BEGIN USART2_Init 0 */

  /* USER CODE END USART2_Init 0 */

  /* USER CODE BEGIN USART2_Init 1 */

  /* USER CODE END USART2_Init 1 */
  huart2.Instance = USART2;
  huart2.Init.BaudRate = 115200;
  huart2.Init.WordLength = UART_WORDLENGTH_8B;
  huart2.Init.StopBits = UART_STOPBITS_1;
  huart2.Init.Parity = UART_PARITY_NONE;
  huart2.Init.Mode = UART_MODE_TX_RX;
  huart2.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart2.Init.OverSampling = UART_OVERSAMPLING_16;
  huart2.Init.OneBitSampling = UART_ONE_BIT_SAMPLE_DISABLE;
  huart2.Init.ClockPrescaler = UART_PRESCALER_DIV1;
  huart2.AdvancedInit.AdvFeatureInit = UART_ADVFEATURE_NO_INIT;
  if (HAL_UART_Init(&huart2) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_UARTEx_SetTxFifoThreshold(&huart2, UART_TXFIFO_THRESHOLD_1_8) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_UARTEx_SetRxFifoThreshold(&huart2, UART_RXFIFO_THRESHOLD_1_8) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_UARTEx_DisableFifoMode(&huart2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART2_Init 2 */

  /* USER CODE END USART2_Init 2 */

}

/**
  * @brief USART3 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART3_UART_Init(void)
{

  /* USER CODE BEGIN USART3_Init 0 */

  /* USER CODE END USART3_Init 0 */

  /* USER CODE BEGIN USART3_Init 1 */

	if(U3.Mode==idx_uart3_baud_115200){

  /* USER CODE END USART3_Init 1 */
  huart3.Instance = USART3;
  huart3.Init.BaudRate = 115200;
  huart3.Init.WordLength = UART_WORDLENGTH_8B;
  huart3.Init.StopBits = UART_STOPBITS_1;
  huart3.Init.Parity = UART_PARITY_NONE;
  huart3.Init.Mode = UART_MODE_TX_RX;
  huart3.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart3.Init.OverSampling = UART_OVERSAMPLING_16;
  huart3.Init.OneBitSampling = UART_ONE_BIT_SAMPLE_DISABLE;
  huart3.Init.ClockPrescaler = UART_PRESCALER_DIV1;
  huart3.AdvancedInit.AdvFeatureInit = UART_ADVFEATURE_NO_INIT;
  if (HAL_UART_Init(&huart3) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART3_Init 2 */

	}
	else if(U3.Mode==idx_uart3_baud_9600){

		  /* USER CODE END USART3_Init 1 */
		  huart3.Instance = USART3;
		  huart3.Init.BaudRate = 9600;
		  huart3.Init.WordLength = UART_WORDLENGTH_8B;
		  huart3.Init.StopBits = UART_STOPBITS_1;
		  huart3.Init.Parity = UART_PARITY_NONE;
		  huart3.Init.Mode = UART_MODE_TX_RX;
		  huart3.Init.HwFlowCtl = UART_HWCONTROL_NONE;
		  huart3.Init.OverSampling = UART_OVERSAMPLING_16;
		  huart3.Init.OneBitSampling = UART_ONE_BIT_SAMPLE_DISABLE;
		  huart3.Init.ClockPrescaler = UART_PRESCALER_DIV1;
		  huart3.AdvancedInit.AdvFeatureInit = UART_ADVFEATURE_NO_INIT;
		  if (HAL_UART_Init(&huart3) != HAL_OK)
		  {
		    Error_Handler();
		  }
	}


  /* USER CODE END USART3_Init 2 */

}

/**
  * @brief USART4 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART4_UART_Init(void)
{

  /* USER CODE BEGIN USART4_Init 0 */

  /* USER CODE END USART4_Init 0 */

  /* USER CODE BEGIN USART4_Init 1 */

  /* USER CODE END USART4_Init 1 */
  huart4.Instance = USART4;
  huart4.Init.BaudRate = 115200;
  huart4.Init.WordLength = UART_WORDLENGTH_8B;
  huart4.Init.StopBits = UART_STOPBITS_1;
  huart4.Init.Parity = UART_PARITY_NONE;
  huart4.Init.Mode = UART_MODE_TX_RX;
  huart4.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart4.Init.OverSampling = UART_OVERSAMPLING_16;
  huart4.Init.OneBitSampling = UART_ONE_BIT_SAMPLE_DISABLE;
  huart4.Init.ClockPrescaler = UART_PRESCALER_DIV1;
  huart4.AdvancedInit.AdvFeatureInit = UART_ADVFEATURE_NO_INIT;
  if (HAL_UART_Init(&huart4) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART4_Init 2 */

  /* USER CODE END USART4_Init 2 */

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOF_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();
  __HAL_RCC_GPIOD_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOC, STATUS_LED_Pin|BUZZER_Pin|OUTPUT_08_Pin|OUTPUT_07_Pin 
                          |OUTPUT_01_Pin|OUTPUT_03_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(SPI1_CS_GPIO_Port, SPI1_CS_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOD, OUTPUT_06_Pin|OUTPUT_05_Pin|EMG_LAMP_Pin|RIGHT_LAMP_Pin 
                          |LEFT_LAMP_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOA, OUTPUT_04_Pin|OUTPUT_02_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pins : SWITCH_04_Pin SWITCH_03_Pin SWITCH_02_Pin */
  GPIO_InitStruct.Pin = SWITCH_04_Pin|SWITCH_03_Pin|SWITCH_02_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /*Configure GPIO pins : STATUS_LED_Pin BUZZER_Pin OUTPUT_08_Pin OUTPUT_07_Pin 
                           OUTPUT_01_Pin OUTPUT_03_Pin */
  GPIO_InitStruct.Pin = STATUS_LED_Pin|BUZZER_Pin|OUTPUT_08_Pin|OUTPUT_07_Pin 
                          |OUTPUT_01_Pin|OUTPUT_03_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /*Configure GPIO pin : SPI1_CS_Pin */
  GPIO_InitStruct.Pin = SPI1_CS_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  HAL_GPIO_Init(SPI1_CS_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pins : OUTPUT_06_Pin OUTPUT_05_Pin EMG_LAMP_Pin RIGHT_LAMP_Pin 
                           LEFT_LAMP_Pin */
  GPIO_InitStruct.Pin = OUTPUT_06_Pin|OUTPUT_05_Pin|EMG_LAMP_Pin|RIGHT_LAMP_Pin 
                          |LEFT_LAMP_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  HAL_GPIO_Init(GPIOD, &GPIO_InitStruct);

  /*Configure GPIO pins : OUTPUT_04_Pin OUTPUT_02_Pin */
  GPIO_InitStruct.Pin = OUTPUT_04_Pin|OUTPUT_02_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /*Configure GPIO pins : INPUT_01_Pin INPUT_02_Pin INPUT_03_Pin INPUT_04_Pin */
  GPIO_InitStruct.Pin = INPUT_01_Pin|INPUT_02_Pin|INPUT_03_Pin|INPUT_04_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(GPIOD, &GPIO_InitStruct);

  /*Configure GPIO pins : INPUT_05_Pin INPUT_06_Pin INPUT_07_Pin INPUT_08_Pin 
                           SWITCH_01_Pin */
  GPIO_InitStruct.Pin = INPUT_05_Pin|INPUT_06_Pin|INPUT_07_Pin|INPUT_08_Pin 
                          |SWITCH_01_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

}

/* USER CODE BEGIN 4 */

//=============================================================================================
//=============================================================================================
//=============================================================================================
//=============================================================================================
void Init_Value(void)
{
	MAIN.Idx=0;
	MAIN.Stat=0;

	btn_LEFT.Togg=button_released;
	btn_RIGHT.Togg=button_released;
	btn_EMG.Togg=button_released;

}
//=============================================================================================
//=============================================================================================
void DISP_LCD_RESET(void)
{

	LCD.Txlen=sprintf(LCD.Txstr,"%c%c",(uint8_t)CHAR_LCD_RESET,(uint8_t)0);
	if(HAL_OK==HAL_UART_Transmit(&huart4,LCD.Txstr,(uint16_t)1,(uint32_t)10)){}
	HAL_Delay(50);

}
//=============================================================================================
//=============================================================================================
void DISP_LCD_SET_CGRAM(void)
{

	uint8_t CGRAM_CHAR1[8]={0x00,0x0F,0x00,0x01,0x05,0x0B,0x09,0x07};  // custom user character no.1
	uint8_t CGRAM_CHAR2[8]={0x00,0x0F,0x00,0x06,0x01,0x07,0x09,0x07};  // custom user character no.2
	uint8_t CGRAM_CHAR3[8]={0x00,0x08,0x0C,0x0E,0x0F,0x0E,0x0C,0x08};  // custom user character no.3
	uint8_t CGRAM_CHAR4[8]={0x00,0x00,0x00,0x0E,0x12,0x12,0x12,0x12};  // custom user character no.4
	uint8_t CGRAM_CHAR5[8]={0x1F,0x00,0x00,0x00,0x00,0x0E,0x0E,0x00};  // custom user character no.5
	uint8_t CGRAM_CHAR6[8]={0x1F,0x00,0x00,0x00,0x0E,0x0E,0x0E,0x00};  // custom user character no.6
	uint8_t CGRAM_CHAR7[8]={0x07,0x08,0x07,0x08,0x07,0x08,0x07,0x00};  // custom user character no.7
	uint8_t CGRAM_CHAR8[8]={0x01,0x01,0x01,0x01,0x01,0x01,0x1E,0x00};  // custom user character no.8

	uint8_t i,j;
	char data[8];
	for(i=1; i<=8; i++){

		switch(i){
			case 1:for(j=0; j<8; j++){data[j]=CGRAM_CHAR1[j];}break;
			case 2:for(j=0; j<8; j++){data[j]=CGRAM_CHAR2[j];}break;
			case 3:for(j=0; j<8; j++){data[j]=CGRAM_CHAR3[j];}break;
			case 4:for(j=0; j<8; j++){data[j]=CGRAM_CHAR4[j];}break;
			case 5:for(j=0; j<8; j++){data[j]=CGRAM_CHAR5[j];}break;
			case 6:for(j=0; j<8; j++){data[j]=CGRAM_CHAR6[j];}break;
			case 7:for(j=0; j<8; j++){data[j]=CGRAM_CHAR7[j];}break;
			case 8:for(j=0; j<8; j++){data[j]=CGRAM_CHAR8[j];}break;
			default:return;
		}

		LCD.Txlen=sprintf(LCD.Txstr,"%c%c%c%c%c%c%c%c%c%c",(uint8_t)CHAR_LCD_CGRAM,(uint8_t)i,data[0],data[1],data[2],data[3],data[4],data[5],data[6],data[7]);
		if(HAL_OK==HAL_UART_Transmit(&huart4,LCD.Txstr,(uint16_t)LCD.Txlen,(uint32_t)100)){
		}
		HAL_Delay(5);
	}
	//delay_ms(100);
	HAL_Delay(50);
}
//=============================================================================================
//=============================================================================================
void DISP_LCD_POS(uint8_t x, uint8_t y)
{
	LCD.Txlen=sprintf(LCD.Txstr,"%c%c%c",(uint8_t)CHAR_LCD_LINE,(uint8_t)x,(uint8_t)y);
	if(HAL_OK==HAL_UART_Transmit(&huart4,LCD.Txstr,(uint16_t)LCD.Txlen,(uint32_t)100)){
	}
	//HAL_Delay(5);
}
//=============================================================================================
//=============================================================================================
void DISP_LCD_CLEAR(uint8_t line)
{
	DISP_LCD_POS(1,line);
	LCD.Txlen=sprintf(LCD.Txstr,"%c                %c",(uint8_t)CHAR_LCD_SHOW,(uint8_t)0);
	if(HAL_OK==HAL_UART_Transmit(&huart4,LCD.Txstr,(uint16_t)LCD.Txlen,(uint32_t)100)){
	}
}
//=============================================================================================
//=============================================================================================
//void DISP_LCD_SHOW(uint8_t line, uint8_t *plcd)
void DISP_LCD_SHOW(uint8_t line,char *plcd)
{
	DISP_LCD_POS(1,line);
	LCD.Txlen=sprintf(LCD.Txstr,"%c%s%c",(uint8_t)CHAR_LCD_SHOW,plcd,(uint8_t)0);
	if(HAL_OK==HAL_UART_Transmit(&huart4,LCD.Txstr,(uint16_t)LCD.Txlen,(uint32_t)100)){
	}
}
//=============================================================================================
//=============================================================================================
void DISP_LCD_VERSION(void)
{

	DISP_LCD_POS(1,1);
	LCD.Txlen=sprintf(LCD.Txstr,"%c%s%c",(uint8_t)CHAR_LCD_SHOW,STR_FILE_L1,(uint8_t)0);
	if(HAL_OK==HAL_UART_Transmit(&huart4,LCD.Txstr,(uint16_t)LCD.Txlen,(uint32_t)100)){
	}

	DISP_LCD_POS(1,2);
	LCD.Txlen=sprintf(LCD.Txstr,"%c%s%c",(uint8_t)CHAR_LCD_SHOW,STR_FILE_L2,(uint8_t)0);
	if(HAL_OK==HAL_UART_Transmit(&huart4,LCD.Txstr,(uint16_t)LCD.Txlen,(uint32_t)100)){
	}
}
//=============================================================================================
//=============================================================================================
void DISP_OutAllOFf(void)
{
	DISP_LCD_POS(1,1);
	LCD.Txlen=sprintf(LCD.Txstr,"%c  * warning! *  %c",(uint8_t)CHAR_LCD_SHOW,(uint8_t)0);
	if(HAL_OK==HAL_UART_Transmit(&huart4,LCD.Txstr,(uint16_t)LCD.Txlen,(uint32_t)100)){
	}
	DISP_LCD_POS(1,2);
	LCD.Txlen=sprintf(LCD.Txstr,"%c Output All Off %c",(uint8_t)CHAR_LCD_SHOW,(uint8_t)0);
	if(HAL_OK==HAL_UART_Transmit(&huart4,LCD.Txstr,(uint16_t)LCD.Txlen,(uint32_t)100)){
	}
}
//=============================================================================================
//=============================================================================================
void Reset_LcdBlink(uint16_t timevlu)
{
	LCD.Blktmr=0;
	LCD.Blink_on=0;
	LCD.BlktmrVlu=timevlu;
}
//=============================================================================================
//=============================================================================================
void DISP_GENERAL(void)
{
	switch(LCD.Idx){
		case 0:memset(LCD.Txstr,(uint8_t)0,sizeof(LCD.Txstr));LCD.Idx++;break;
		case 1:
			DISP_LCD_POS(1,1);
			LCD.Txlen=sprintf(LCD.Txstr,"%c%s%c",(uint8_t)CHAR_LCD_SHOW,LCD.Line1,(uint8_t)0);
			if(HAL_OK==HAL_UART_Transmit(&huart4,LCD.Txstr,(uint16_t)LCD.Txlen,(uint32_t)100)){
			}
			Start_LcdTimer(10);
			LCD.Idx++;
			break;
		case 2:if(T_LCD.tov){LCD.Idx++;}break;
		case 3:
			DISP_LCD_POS(1,2);
			LCD.Txlen=sprintf(LCD.Txstr,"%c%s%c",(uint8_t)CHAR_LCD_SHOW,LCD.Line2,(uint8_t)0);
			if(HAL_OK==HAL_UART_Transmit(&huart4,LCD.Txstr,(uint16_t)LCD.Txlen,(uint32_t)100)){
			}
			Start_LcdTimer(10);
			LCD.Idx++;
			break;
		case 4:if(T_LCD.tov){LCD.Idx++;}break;

		case 5:LCD.Idx=0;break;

		default:LCD.Idx=0;break;
	}
}
//=============================================================================================
//=============================================================================================
void DISP_MANUAL(uint8_t idx)
{

	uint8_t c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13;
	c1=c2=c3=c4=c5=c6=c7=c8=c9=c10=c11=c12=c13=' ';

	LCD.PointChar=3;  // custom user character no.3
	if(!LCD.Blink_on){
		switch(idx){
			case  0: c1=LCD.PointChar;break;
			case  1: c2=LCD.PointChar;break;
			case  2: c3=LCD.PointChar;break;
			case  3: c4=LCD.PointChar;break;
			case  4: c5=LCD.PointChar;break;
			case  5: c6=LCD.PointChar;break;
			case  6: c7=LCD.PointChar;break;
			case  7: c8=LCD.PointChar;break;
			case  8: c9=LCD.PointChar;break;
			case  9: c10=LCD.PointChar;break;
			case  10: c11=LCD.PointChar;break;
			case  11: c12=LCD.PointChar;break;
			case  12: c13=LCD.PointChar;break;
			default: break;
		}
	}

	if(idx==0){
		sprintf(LCD.Line1,"   * setting *  ");
		sprintf(XYCV_SET.Valstr,"---");
		if(XYCV_SET.Run == idx_xycv_run){
			sprintf(XYCV_SET.Valstr," on");
		}
		else if(XYCV_SET.Run == idx_xycv_stop){
			sprintf(XYCV_SET.Valstr,"off");
		}
		sprintf(LCD.Line2,"%c1:RUN [%s]    ",c1,XYCV_SET.Valstr);
	}
	else if((idx==1)||(idx==2)){
		sprintf(XYCV_SET.Valstr,"---");
		if(XYCV_SET.Dir == idx_xycv_ccw){
			sprintf(XYCV_SET.Valstr,"ccw");
		}
		else if(XYCV_SET.Dir == idx_xycv_cw){
			sprintf(XYCV_SET.Valstr,"cw ");
		}
		sprintf(LCD.Line1,"%c2:DIR [%s]    ",c2,XYCV_SET.Valstr);

		if(idx == 2){
			if(MANU.Stat != 0){c3=LCD.PointChar;}
		}
		memset(XYCV_SET.Valstr,0,sizeof(XYCV_SET.Valstr));
		sprintf(XYCV_SET.Valstr,"%04u",XYCV_SET.Speed);
		XYCV_SET.Valstr[4] = XYCV_SET.Valstr[3];
		XYCV_SET.Valstr[3] = '.';
		sprintf(LCD.Line2,"%c3:SPEED[%s%%]",c3,XYCV_SET.Valstr);

		if(idx == 2){
			if(MANU.Stat == 1){
				if(LCD.Blink_on){LCD.Line2[9] = ' ';}
			}
			else if(MANU.Stat == 2){
				if(LCD.Blink_on){LCD.Line2[10] = ' ';}
			}
			else if(MANU.Stat == 3){
				if(LCD.Blink_on){LCD.Line2[11] = ' ';}
			}
			else if(MANU.Stat == 4){
				if(LCD.Blink_on){LCD.Line2[13] = ' ';}
			}
		}

	}
	else if((idx==3)||(idx==4)){
		if(idx == 3){
			if(MANU.Stat != 0){c4=LCD.PointChar;}
		}
		else if(idx == 4){
			if(MANU.Stat != 0){c5=LCD.PointChar;}
		}
		sprintf(LCD.Line1,"%c4:TORQUE [%03u] ",c4,XYCV_SET.Torq);
		sprintf(LCD.Line2,"%c5:ACCEL [%u]    ",c5,XYCV_SET.Accel);

		if(idx == 3){
			if(MANU.Stat == 1){
				if(LCD.Blink_on){LCD.Line1[11] = ' ';}
			}
			else if(MANU.Stat == 2){
				if(LCD.Blink_on){LCD.Line1[12] = ' ';}
			}
			else if(MANU.Stat == 3){
				if(LCD.Blink_on){LCD.Line1[13] = ' ';}
			}
		}
		else if(idx == 4){
			if(MANU.Stat == 1){
				if(LCD.Blink_on){LCD.Line2[10] = ' ';}
			}
		}

	}
	else if((idx==5)||(idx==6)){
		if(idx == 5){
			if(MANU.Stat != 0){c6=LCD.PointChar;}
		}
		sprintf(LCD.Line1,"%c6:DECEL [%u]    ",c6,XYCV_SET.Decel);
		sprintf(LCD.Line2,"%c7:save         ",c7);

		if(idx == 5){
			if(MANU.Stat == 1){
				if(LCD.Blink_on){LCD.Line1[10] = ' ';}
			}
		}
	}
	else if((idx==7)||(idx==8)){
		sprintf(LCD.Line1,"%c8:zcc?[%07u]",c8,XYCV_SET.Zcc);
		sprintf(LCD.Line2,"%c9:zcc-clear    ",c9);
	}
	else if((idx==9)||(idx==10)){
		sprintf(LCD.Line1,"%c10:f-reset     ",c10);
		sprintf(LCD.Line2,"                ");
	}


	DISP_GENERAL();


}
//=============================================================================================
//=============================================================================================
//=============================================================================================
//=============================================================================================
void RESET_XYCV_DATA(void)
{
	XYCV_SET.Run = idx_xycv_stop;
	XYCV_SET.Dir = idx_xycv_cw;
	XYCV_SET.Speed = 200;
	XYCV_SET.Torq = 90;
	XYCV_SET.Accel = 2;
	XYCV_SET.Decel = 1;
}
//==============================================================
//==============================================================

void Send_XYCV_STAq(void)
{
	U3.strnum = sprintf(U3.TxString,"<sta?>");
	if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
}

void Send_XYCV_RUNq(void)
{
	U3.strnum = sprintf(U3.TxString,"<run?>");
	if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
}

void Send_XYCV_DIRq(void)
{
	U3.strnum = sprintf(U3.TxString,"<dir?>");
	if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
}

void Send_XYCV_SPDSq(void)
{
	U3.strnum = sprintf(U3.TxString,"<spds?>");
	if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
}

void Send_XYCV_TORQq(void)
{
	U3.strnum = sprintf(U3.TxString,"<torq?>");
	if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
}

void Send_XYCV_ACCq(void)
{
	U3.strnum = sprintf(U3.TxString,"<acc?>");
	if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
}

void Send_XYCV_DECq(void)
{
	U3.strnum = sprintf(U3.TxString,"<dec?>");
	if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
}

void Send_XYCV_ZCCq(void)
{
	U3.strnum = sprintf(U3.TxString,"<zcc?>");
	if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
}

//==============================================================
//==============================================================

void Send_XYCV_RUN(uint8_t oper)
{
	char ch1 = 'x';

	if(oper == idx_xycv_run){
		ch1 = '1';
	}
	else if(oper == idx_xycv_stop){
		ch1 = '0';
	}

	U3.strnum = sprintf(U3.TxString,"<run=%c>",ch1);
	if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
}

//==============================================================
//==============================================================

void Send_XYCV_DIR(uint8_t dir)
{
	char ch1 = 'x';

	if(dir == idx_xycv_ccw){
		ch1 = '1';
	}
	else if(dir == idx_xycv_cw){
		ch1 = '0';
	}

	U3.strnum = sprintf(U3.TxString,"<dir=%c>",ch1);
	if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
}

//==============================================================
//==============================================================

void Send_XYCV_SPEED(uint16_t spd)
{
	memset(XYCV_SET.Valstr,0,sizeof(XYCV_SET.Valstr));
	sprintf(XYCV_SET.Valstr,"%04u",spd);
	XYCV_SET.Valstr[4] = XYCV_SET.Valstr[3];
	XYCV_SET.Valstr[3] = '.';

	U3.strnum = sprintf(U3.TxString,"<spds=%s>",XYCV_SET.Valstr);
	if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
}

//==============================================================
//==============================================================

void Send_XYCV_TORQ(uint16_t torq)
{
	memset(XYCV_SET.Valstr,0,sizeof(XYCV_SET.Valstr));
	sprintf(XYCV_SET.Valstr,"%03u",torq);

	U3.strnum = sprintf(U3.TxString,"<torq=%s>",XYCV_SET.Valstr);
	if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
}

//==============================================================
//==============================================================

void Send_XYCV_ACCEL(uint8_t acc)
{
	U3.strnum = sprintf(U3.TxString,"<acc=%d>",acc);
	if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
}

//==============================================================
//==============================================================

void Send_XYCV_DECEL(uint8_t dec)
{
	U3.strnum = sprintf(U3.TxString,"<dec=%d>",dec);
	if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
}

//==============================================================
//==============================================================

void Send_XYCV_SAVE(void)
{
	U3.strnum = sprintf(U3.TxString,"<save>");
	if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
}

//==============================================================
//==============================================================

void Send_XYCV_ZCC_CLEAR(void)
{
	U3.strnum = sprintf(U3.TxString,"<zcc-clear>");
	if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
}

//==============================================================
//==============================================================

void Send_XYCV_FRESET(void)
{
	U3.strnum = sprintf(U3.TxString,"<freset>");
	if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
}

//==============================================================
//==============================================================

void XYCONV_WORK(void)
{

	if(SWON_SET()==button_released){return;}

	Beep_Once();

	while(1){
		if(SWON_SET()==button_released){
			break;
		}
	}

	if(SWON_SET()==button_pressed){btn_SET.Togg=button_pressed;}
	else if(SWON_SET()==button_released){btn_SET.Togg=button_released;}

	if(SWON_SHIFT()==button_pressed){btn_SHIFT.Togg=button_pressed;}
	else if(SWON_SHIFT()==button_released){btn_SHIFT.Togg=button_released;}

	if(SWON_UP()==button_pressed){btn_UP.Togg=button_pressed;}
	else if(SWON_UP()==button_released){btn_UP.Togg=button_released;}

	if(SWON_DOWN()==button_pressed){btn_DOWN.Togg=button_pressed;}
	else if(SWON_DOWN()==button_released){btn_DOWN.Togg=button_released;}


	uint8_t i,j;
	uint8_t sidx = 0;
	char str_num[16];


	MANU.Idx=0;
	MANU.Stat = 0;

	Reset_LcdBlink(500);


	while(1){



		switch(sidx){
			case 0:
				Send_XYCV_RUNq();
				Start_DelayTimer(200);
				sidx++;
				break;
			case 1:
				if(T_DELAY.tov){
					Send_XYCV_DIRq();
					Start_DelayTimer(200);
					sidx++;
				}
				break;
			case 2:
				if(T_DELAY.tov){
					Send_XYCV_SPDSq();
					Start_DelayTimer(200);
					sidx++;
				}
				break;
			case 3:
				if(T_DELAY.tov){
					Send_XYCV_TORQq();
					Start_DelayTimer(200);
					sidx++;
				}
				break;
			case 4:
				if(T_DELAY.tov){
					Send_XYCV_ACCq();
					Start_DelayTimer(200);
					sidx++;
				}
				break;
			case 5:
				if(T_DELAY.tov){
					Send_XYCV_DECq();
					Start_DelayTimer(200);
					sidx++;
				}
				break;
			case 6:
				break;

			default:
				break;
		}




		DISP_MANUAL(MANU.Idx);
		RCV_WORK();

		if(U1.Rcv_Flag){
			U1.Rcv_Flag=0;
			U3.strnum = sprintf(U3.TxString,"%s%c%c",U1.RxString,CHAR_CR,CHAR_LF);
			if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){}
		}

		else if(U3.Xycv_Rcv_Flag){
			U3.Xycv_Rcv_Flag=0;

			//-----------------  <run?> 리턴
			if(strncmp(U3.RxString,"r<run:",6) == 0){
				if(U3.RxString[6] == '0'){
					XYCV_SET.Run = idx_xycv_stop;
				}
				else if(U3.RxString[6] == '1'){
					XYCV_SET.Run = idx_xycv_run;
				}
			}
			//-----------------
			//-----------------  <dir?> 리턴
			else if(strncmp(U3.RxString,"r<dir:",6) == 0){
				if(U3.RxString[6] == '0'){
					XYCV_SET.Dir = idx_xycv_cw;
				}
				else if(U3.RxString[6] == '1'){
					XYCV_SET.Dir = idx_xycv_ccw;
				}
			}
			//-----------------
			//-----------------  <spds?> 리턴
			else if(strncmp(U3.RxString,"r<spds:",7) == 0){

				memset(str_num,0,sizeof(str_num));

                for(i = 0 , j = 7 ;  ; j++){
                	if(i > 4){
                		break;
                	}
                    if(CHECK_NUM(U3.RxString[j])){
                    	str_num[i++] = U3.RxString[j];
                    }
                    else if(U3.RxString[j] == '>'){
                        if(U3.RxString[--j] == '.'){
                        	str_num[i] = '0';
                        }
                        XYCV_RCV.Speed = atol(str_num);
                        if((XYCV_RCV.Speed >= 100) && (XYCV_RCV.Speed <= 1000)){
                        	XYCV_SET.Speed = XYCV_RCV.Speed;
                        }
                        break;
                    }
                    else if(U3.RxString[j] == '.'){
                        // nothing
                    }
                }
			}
			//-----------------
			//-----------------  <torq?> 리턴
			else if(strncmp(U3.RxString,"r<torq:",7) == 0){

				memset(str_num,0,sizeof(str_num));

                for(i = 0 , j = 7 ;  ; j++){
                	if(i > 3){
                		break;
                	}
                    if(CHECK_NUM(U3.RxString[j])){
                    	str_num[i++] = U3.RxString[j];
                    }
                    else if(U3.RxString[j] == '>'){
                        XYCV_RCV.Torq = atol(str_num);
                        if(XYCV_RCV.Torq <= 100){
                        	XYCV_SET.Torq = XYCV_RCV.Torq;
                        }
                        break;
                    }
                    else{
                    	break;
                    }
                }
			}
			//-----------------
			//-----------------  <acc?> 리턴
			else if(strncmp(U3.RxString,"r<acc:",6) == 0){
				if(U3.RxString[7] == '>'){
					if(CHECK_NUM(U3.RxString[6])){
						XYCV_SET.Accel = U3.RxString[6] - 0x30;
					}
				}
			}
			//-----------------
			//-----------------  <dec?> 리턴
			else if(strncmp(U3.RxString,"r<dec:",6) == 0){
				if(U3.RxString[7] == '>'){
					if(CHECK_NUM(U3.RxString[6])){
						XYCV_SET.Decel = U3.RxString[6] - 0x30;
					}
				}
			}
			//-----------------
			//-----------------  <zcc?> 리턴
			else if(strncmp(U3.RxString,"r<zcc:",6) == 0){

				i = 0;
				j = 6;
				memset(str_num,0,sizeof(str_num));

				while(1){
					if(i > 7){
						break;
					}
					if(U3.RxString[j] == '>'){
						XYCV_SET.Zcc = atol(str_num);
						break;
					}
					else if(CHECK_NUM(U3.RxString[j])){
						str_num[i++] = U3.RxString[j++];
					}
					else{
						break;
					}
				}
			}
			//-----------------

			U1.strnum = sprintf(U1.TxString,"%s%c%c",U3.RxString,CHAR_CR,CHAR_LF);
			if(HAL_OK==HAL_UART_Transmit(&huart1,U1.TxString,(uint16_t)U1.strnum,(uint32_t)100)){}
		}


		//--------------------------------------
		if(SWON_SHIFT()==button_pressed){
			if(btn_SHIFT.Togg==button_released){
				btn_SHIFT.Togg=button_pressed;

				Beep_Once();

				switch(MANU.Idx){

					case 0:
						if(XYCV_SET.Run == idx_xycv_run){
							XYCV_SET.Run = idx_xycv_stop;
							Send_XYCV_RUN(XYCV_SET.Run);
						}
						else{
							XYCV_SET.Run = idx_xycv_run;
							Send_XYCV_RUN(XYCV_SET.Run);
						}
						break;

					case 1:
						if(XYCV_SET.Dir == idx_xycv_ccw){
							XYCV_SET.Dir = idx_xycv_cw;
							Send_XYCV_DIR(XYCV_SET.Dir);
						}
						else{
							XYCV_SET.Dir = idx_xycv_ccw;
							Send_XYCV_DIR(XYCV_SET.Dir);
						}
						break;

					case 2:
						if(MANU.Stat == 0){
							MANU.Stat = 1;
						}
						else if(MANU.Stat == 1){
							MANU.Stat = 2;
						}
						else if(MANU.Stat == 2){
							MANU.Stat = 3;
						}
						else if(MANU.Stat == 3){
							MANU.Stat = 4;
						}
						else if(MANU.Stat == 4){
							MANU.Stat = 0;
						}
						break;

					case 3:
						if(MANU.Stat == 0){
							MANU.Stat = 1;
						}
						else if(MANU.Stat == 1){
							MANU.Stat = 2;
						}
						else if(MANU.Stat == 2){
							MANU.Stat = 3;
						}
						else if(MANU.Stat == 3){
							MANU.Stat = 0;
						}
						break;

					case 4:
						if(MANU.Stat == 0){
							MANU.Stat = 1;
						}
						else if(MANU.Stat == 1){
							MANU.Stat = 0;
						}
						break;

					case 5:
						if(MANU.Stat == 0){
							MANU.Stat = 1;
						}
						else if(MANU.Stat == 1){
							MANU.Stat = 0;
						}
						break;

					case 6:
						Send_XYCV_SAVE();
						break;

					case 7:
						Send_XYCV_ZCCq();
						break;

					case 8:
						Send_XYCV_ZCC_CLEAR();
						break;

					case 9:
						Send_XYCV_FRESET();
						break;

					default:break;
				}

			}
		}
		else if(SWON_SHIFT()==button_released){
			btn_SHIFT.Togg=button_released;
		}
		//--------------------------------------

		//--------------------------------------
		if(SWON_UP()==button_pressed){
			if(btn_UP.Togg==button_released){
				btn_UP.Togg=button_pressed;
				Beep_Once();
				Reset_LcdBlink(500);
				if(MANU.Stat == 0){
					if(MANU.Idx == 0){MANU.Idx = 9;}
					else{MANU.Idx--;}
				}
				else{
					//------------
					if(MANU.Idx == 2){
						if(MANU.Stat == 1){
							XYCV_SET.Speed = 1000;
						}
						else if(MANU.Stat == 2){
							if(XYCV_SET.Speed < 901){
								XYCV_SET.Speed += 100;
							}
						}
						else if(MANU.Stat == 3){
							if(XYCV_SET.Speed < 991){
								XYCV_SET.Speed += 10;
							}
						}
						else if(MANU.Stat == 4){
							if(XYCV_SET.Speed < 1000){
								XYCV_SET.Speed += 1;
							}
						}
						Send_XYCV_SPEED(XYCV_SET.Speed);
					}
					//------------
					else if(MANU.Idx == 3){
						if(MANU.Stat == 1){
							XYCV_SET.Torq = 100;
						}
						else if(MANU.Stat == 2){
							if(XYCV_SET.Torq < 91){
								XYCV_SET.Torq += 10;
							}
						}
						else if(MANU.Stat == 3){
							if(XYCV_SET.Torq < 100){
								XYCV_SET.Torq += 1;
							}
						}
						Send_XYCV_TORQ(XYCV_SET.Torq);
					}
					//------------
					else if(MANU.Idx == 4){
						if(MANU.Stat == 1){
							if(XYCV_SET.Accel < 9){
								XYCV_SET.Accel++;
							}
							Send_XYCV_ACCEL(XYCV_SET.Accel);
						}
					}
					//------------
					else if(MANU.Idx == 5){
						if(MANU.Stat == 1){
							if(XYCV_SET.Decel < 9){
								XYCV_SET.Decel++;
							}
							Send_XYCV_DECEL(XYCV_SET.Decel);
						}
					}
					//------------
				}

			}
		}
		else if(SWON_UP()==button_released){
			btn_UP.Togg=button_released;
		}
		//--------------------------------------

		//--------------------------------------
		if(SWON_DOWN()==button_pressed){
			if(btn_DOWN.Togg==button_released){
				btn_DOWN.Togg=button_pressed;
				Beep_Once();
				Reset_LcdBlink(500);
				if(MANU.Stat == 0){
					if(MANU.Idx >= 9){MANU.Idx = 0;}
					else{MANU.Idx++;}
				}
				else{
					//------------
					if(MANU.Idx == 2){
						if(MANU.Stat == 1){
							XYCV_SET.Speed = 100;
						}
						else if(MANU.Stat == 2){
							if(XYCV_SET.Speed > 199){
								XYCV_SET.Speed -= 100;
							}
						}
						else if(MANU.Stat == 3){
							if(XYCV_SET.Speed > 109){
								XYCV_SET.Speed -= 10;
							}
						}
						else if(MANU.Stat == 4){
							if(XYCV_SET.Speed > 100){
								XYCV_SET.Speed -= 1;
							}
						}
						Send_XYCV_SPEED(XYCV_SET.Speed);
					}
					//------------
					else if(MANU.Idx == 3){
						if(MANU.Stat == 1){
							if(XYCV_SET.Torq == 100){
								XYCV_SET.Torq = 0;
							}
						}
						else if(MANU.Stat == 2){
							if(XYCV_SET.Torq > 9){
								XYCV_SET.Torq -= 10;
							}
						}
						else if(MANU.Stat == 3){
							if(XYCV_SET.Torq > 0){
								XYCV_SET.Torq -= 1;
							}
						}
						Send_XYCV_TORQ(XYCV_SET.Torq);
					}
					//------------
					else if(MANU.Idx == 4){
						if(MANU.Stat == 1){
							if(XYCV_SET.Accel > 0){
								XYCV_SET.Accel--;
							}
							Send_XYCV_ACCEL(XYCV_SET.Accel);
						}
					}
					//------------
					else if(MANU.Idx == 5){
						if(MANU.Stat == 1){
							if(XYCV_SET.Decel > 0){
								XYCV_SET.Decel--;
							}
							Send_XYCV_DECEL(XYCV_SET.Decel);
						}
					}
					//------------
				}
			}
		}
		else if(SWON_DOWN()==button_released){
			btn_DOWN.Togg=button_released;
		}
		//--------------------------------------

		//--------------------------------------
		if(SWON_SET()==button_pressed){
			if(btn_SET.Togg==button_released){
				btn_SET.Togg=button_pressed;
				Beep_Once();
				while(1){
					if(SWON_SET()==button_released){
						break;
					}
				}
				DISP_LCD_VERSION();
				MAIN.Idx=0;
				return;
			}
		}
		else if(SWON_SET()==button_released){
			btn_SET.Togg=button_released;
		}
		//--------------------------------------



	}



}
//=============================================================================================
//=============================================================================================
//=============================================================================================
//=============================================================================================

uint8_t SWON_SET(void)
{
	if(btn_SET.Stat==button_released){
		if(SW_01.Input){
			btn_SET.Stat=button_pressed;
		}
	}
	else if(!SW_01.Input){
		btn_SET.Stat=button_released;
	}
	return(btn_SET.Stat);
}
//=============================================
uint8_t SWON_SHIFT(void)
{
	if(btn_SHIFT.Stat==button_released){
		if(SW_02.Input){
			btn_SHIFT.Stat=button_pressed;
		}
	}
	else if(!SW_02.Input){
		btn_SHIFT.Stat=button_released;
	}
	return(btn_SHIFT.Stat);
}
//=============================================
uint8_t SWON_UP(void)
{
	if(btn_UP.Stat==button_released){
		if(SW_03.Input){
			btn_UP.Stat=button_pressed;
		}
	}
	else if(!SW_03.Input){
		btn_UP.Stat=button_released;
	}
	return(btn_UP.Stat);
}
//=============================================
uint8_t SWON_DOWN(void)
{
	if(btn_DOWN.Stat==button_released){
		if(SW_04.Input){
			btn_DOWN.Stat=button_pressed;
		}
	}
	else if(!SW_04.Input){
		btn_DOWN.Stat=button_released;
	}
	return(btn_DOWN.Stat);
}
//=============================================
//=============================================
uint8_t SWON_LEFT(void)
{
	if(btn_LEFT.Stat==button_released){
		if(SW_02.Input){
			btn_LEFT.Stat=button_pressed;
		}
	}
	else if(!SW_02.Input){
		btn_LEFT.Stat=button_released;
	}
	return(btn_LEFT.Stat);
}
//=============================================
uint8_t SWON_RIGHT(void)
{
	if(btn_RIGHT.Stat==button_released){
		if(SW_03.Input){
			btn_RIGHT.Stat=button_pressed;
		}
	}
	else if(!SW_03.Input){
		btn_RIGHT.Stat=button_released;
	}
	return(btn_RIGHT.Stat);
}
//=============================================
uint8_t SWON_EMG(void)
{
	if(btn_EMG.Stat==button_released){
		if(SW_04.Input){
			btn_EMG.Stat=button_pressed;
		}
	}
	else if(!SW_04.Input){
		btn_EMG.Stat=button_released;
	}
	return(btn_EMG.Stat);
}
//=============================================================================================
//=============================================================================================
void Start_DelayTimer(uint16_t dtime)
{
	T_DELAY.tov=1;
	T_DELAY.vlue=dtime;
	T_DELAY.tmrs=0;
	T_DELAY.tov=0;
}
//=============================================================================================
void Start_ManuTimer(uint16_t dtime)
{
	T_MANU.tov=1;
	T_MANU.vlue=dtime;
	T_MANU.tmrs=0;
	T_MANU.tov=0;
}
//=============================================================================================
void Start_LcdTimer(uint16_t dtime)
{
	T_LCD.tov=1;
	T_LCD.vlue=dtime;
	T_LCD.tmrs=0;
	T_LCD.tov=0;
}
//=============================================================================================
void Start_U1G_Timer(uint16_t dtime)
{
	U1G.tov=1;
	U1G.vlue=dtime;
	U1G.tmrs=0;
	U1G.tov=0;
}
//=============================================================================================
void Start_U2G_Timer(uint16_t dtime)
{
	U2G.tov=1;
	U2G.vlue=dtime;
	U2G.tmrs=0;
	U2G.tov=0;
}
//=============================================================================================
void Start_U3G_Timer(uint16_t dtime)
{
	U3G.tov=1;
	U3G.vlue=dtime;
	U3G.tmrs=0;
	U3G.tov=0;
}
//=============================================================================================
void Reset_Rcv1Timer(uint8_t dtime)
{
	U1.Rcv_OverTmr=1;
	U1.RcvTimeVal=dtime;
	U1.RcvTimer=0;
	U1.Rcv_OverTmr=0;
}
//=============================================================================================
void Reset_Rcv2Timer(uint8_t dtime)
{
	U2.Rcv_OverTmr=1;
	U2.RcvTimeVal=dtime;
	U2.RcvTimer=0;
	U2.Rcv_OverTmr=0;
}
//=============================================================================================
void Reset_Rcv3Timer(uint8_t dtime)
{
	U3.Rcv_OverTmr=1;
	U3.RcvTimeVal=dtime;
	U3.RcvTimer=0;
	U3.Rcv_OverTmr=0;
}
//=============================================================================================
void TimerCheck(void)
{
	if(!T_DELAY.tov){if(++T_DELAY.tmrs>=T_DELAY.vlue){T_DELAY.tov=1;}}
	if(!T_MANU.tov){if(++T_MANU.tmrs>=T_MANU.vlue){T_MANU.tov=1;}}
	if(!T_LCD.tov){if(++T_LCD.tmrs>=T_LCD.vlue){T_LCD.tov=1;}}

	if(!U1G.tov){if(++U1G.tmrs>=U1G.vlue){U1G.tov=1;}}
	if(!U2G.tov){if(++U2G.tmrs>=U2G.vlue){U2G.tov=1;}}
	if(!U3G.tov){if(++U3G.tmrs>=U3G.vlue){U3G.tov=1;}}
	if(!U1.Rcv_OverTmr){if(++U1.RcvTimer>=U1.RcvTimeVal){U1.Rcv_OverTmr=1;}}
	if(!U2.Rcv_OverTmr){if(++U2.RcvTimer>=U2.RcvTimeVal){U2.Rcv_OverTmr=1;}}
	if(!U3.Rcv_OverTmr){if(++U3.RcvTimer>=U3.RcvTimeVal){U3.Rcv_OverTmr=1;}}

	if(++LCD.Blktmr>LCD.BlktmrVlu){
		LCD.Blktmr=0;
		if(LCD.Blink_on){LCD.Blink_on=0;}
		else{LCD.Blink_on=1;}
	}
}
//=============================================================================================
void InputCheck(void)
{

	prtb_in=GPIOB->IDR;
	prtc_in=GPIOC->IDR;
	prtd_in=GPIOD->IDR;

	//------------------------------------------------
	if(prtb_in&(uint16_t)0x0080){SW_01.New_Input=0;}  // SW-01 PB7
	else{SW_01.New_Input=1;}
	if(SW_01.New_Input){if(++SW_01.Tmr>SWITCH_INPUT_CHECK_TIME){SW_01.Input=1;}}
	else{SW_01.Tmr=0;SW_01.Input=0;}
	//------------------------------------------------
	//------------------------------------------------
	if(prtc_in&(uint16_t)0x0400){SW_02.New_Input=0;}  // SW-02 PC10
	else{SW_02.New_Input=1;}
	if(SW_02.New_Input){if(++SW_02.Tmr>SWITCH_INPUT_CHECK_TIME){SW_02.Input=1;}}
	else{SW_02.Tmr=0;SW_02.Input=0;}
	//------------------------------------------------
	//------------------------------------------------
	if(prtc_in&(uint16_t)0x1000){SW_03.New_Input=0;}  // SW-03 PC12
	else{SW_03.New_Input=1;}
	if(SW_03.New_Input){if(++SW_03.Tmr>SWITCH_INPUT_CHECK_TIME){SW_03.Input=1;}}
	else{SW_03.Tmr=0;SW_03.Input=0;}
	//------------------------------------------------
	//------------------------------------------------
	if(prtc_in&(uint16_t)0x0800){SW_04.New_Input=0;}  // SW-04 PC11
	else{SW_04.New_Input=1;}
	if(SW_04.New_Input){if(++SW_04.Tmr>SWITCH_INPUT_CHECK_TIME){SW_04.Input=1;}}
	else{SW_04.Tmr=0;SW_04.Input=0;}
	//------------------------------------------------

	//------------------------------------------------
	if(prtd_in&(uint16_t)0x0008){INP_01.New_Input=0;}  // IN-01 PD3
	else{INP_01.New_Input=1;}
	if(INP_01.New_Input){if(++INP_01.Tmr>INPUT_CHECK_TIME){INP_01.Input=1;}}
	else{INP_01.Tmr=0;INP_01.Input=0;}
	//------------------------------------------------
	//------------------------------------------------
	if(prtd_in&(uint16_t)0x0010){INP_02.New_Input=0;}  // IN-02 PD4
	else{INP_02.New_Input=1;}
	if(INP_02.New_Input){if(++INP_02.Tmr>INPUT_CHECK_TIME){INP_02.Input=1;}}
	else{INP_02.Tmr=0;INP_02.Input=0;}
	//------------------------------------------------
	//------------------------------------------------
	if(prtd_in&(uint16_t)0x0020){INP_03.New_Input=0;}  // IN-03 PD5
	else{INP_03.New_Input=1;}
	if(INP_03.New_Input){if(++INP_03.Tmr>INPUT_CHECK_TIME){INP_03.Input=1;}}
	else{INP_03.Tmr=0;INP_03.Input=0;}
	//------------------------------------------------
	//------------------------------------------------
	if(prtd_in&(uint16_t)0x0040){INP_04.New_Input=0;}  // IN-04 PD6
	else{INP_04.New_Input=1;}
	if(INP_04.New_Input){if(++INP_04.Tmr>INPUT_CHECK_TIME){INP_04.Input=1;}}
	else{INP_04.Tmr=0;INP_04.Input=0;}
	//------------------------------------------------
	//------------------------------------------------
	if(prtb_in&(uint16_t)0x0008){INP_05.New_Input=0;}  // IN-05 PB3
	else{INP_05.New_Input=1;}
	if(INP_05.New_Input){if(++INP_05.Tmr>INPUT_CHECK_TIME){INP_05.Input=1;}}
	else{INP_05.Tmr=0;INP_05.Input=0;}
	//------------------------------------------------
	//------------------------------------------------
	if(prtb_in&(uint16_t)0x0010){INP_06.New_Input=0;}  // IN-05 PB4
	else{INP_06.New_Input=1;}
	if(INP_06.New_Input){if(++INP_06.Tmr>INPUT_CHECK_TIME){INP_06.Input=1;}}
	else{INP_06.Tmr=0;INP_06.Input=0;}
	//------------------------------------------------
	//------------------------------------------------
	if(prtb_in&(uint16_t)0x0020){INP_07.New_Input=0;}  // IN-05 PB5
	else{INP_07.New_Input=1;}
	if(INP_07.New_Input){if(++INP_07.Tmr>INPUT_CHECK_TIME){INP_07.Input=1;}}
	else{INP_07.Tmr=0;INP_07.Input=0;}
	//------------------------------------------------
	//------------------------------------------------
	if(prtb_in&(uint16_t)0x0040){INP_08.New_Input=0;}  // IN-05 PB6
	else{INP_08.New_Input=1;}
	if(INP_08.New_Input){if(++INP_08.Tmr>INPUT_CHECK_TIME){INP_08.Input=1;}}
	else{INP_08.Tmr=0;INP_08.Input=0;}
	//------------------------------------------------



}

//=============================================================================================
//=============================================================================================
void Upload_Output(void)
{


	if(OUT_01.Output){HAL_GPIO_WritePin(OUTPUT_01_GPIO_Port, OUTPUT_01_Pin, GPIO_PIN_SET);}
	else{HAL_GPIO_WritePin(OUTPUT_01_GPIO_Port, OUTPUT_01_Pin, GPIO_PIN_RESET);}

	if(OUT_02.Output){HAL_GPIO_WritePin(OUTPUT_02_GPIO_Port, OUTPUT_02_Pin, GPIO_PIN_SET);}
	else{HAL_GPIO_WritePin(OUTPUT_02_GPIO_Port, OUTPUT_02_Pin, GPIO_PIN_RESET);}

	if(OUT_03.Output){HAL_GPIO_WritePin(OUTPUT_03_GPIO_Port, OUTPUT_03_Pin, GPIO_PIN_SET);}
	else{HAL_GPIO_WritePin(OUTPUT_03_GPIO_Port, OUTPUT_03_Pin, GPIO_PIN_RESET);}

	if(OUT_04.Output){HAL_GPIO_WritePin(OUTPUT_04_GPIO_Port, OUTPUT_04_Pin, GPIO_PIN_SET);}
	else{HAL_GPIO_WritePin(OUTPUT_04_GPIO_Port, OUTPUT_04_Pin, GPIO_PIN_RESET);}

	if(OUT_05.Output){HAL_GPIO_WritePin(OUTPUT_05_GPIO_Port, OUTPUT_05_Pin, GPIO_PIN_SET);}
	else{HAL_GPIO_WritePin(OUTPUT_05_GPIO_Port, OUTPUT_05_Pin, GPIO_PIN_RESET);}

	if(OUT_06.Output){HAL_GPIO_WritePin(OUTPUT_06_GPIO_Port, OUTPUT_06_Pin, GPIO_PIN_SET);}
	else{HAL_GPIO_WritePin(OUTPUT_06_GPIO_Port, OUTPUT_06_Pin, GPIO_PIN_RESET);}

	if(OUT_07.Output){HAL_GPIO_WritePin(OUTPUT_07_GPIO_Port, OUTPUT_07_Pin, GPIO_PIN_SET);}
	else{HAL_GPIO_WritePin(OUTPUT_07_GPIO_Port, OUTPUT_07_Pin, GPIO_PIN_RESET);}

	if(OUT_08.Output){HAL_GPIO_WritePin(OUTPUT_08_GPIO_Port, OUTPUT_08_Pin, GPIO_PIN_SET);}
	else{HAL_GPIO_WritePin(OUTPUT_08_GPIO_Port, OUTPUT_08_Pin, GPIO_PIN_RESET);}




	if(BUZZ.Output){HAL_GPIO_WritePin(BUZZER_GPIO_Port, BUZZER_Pin, GPIO_PIN_SET);}
	else{HAL_GPIO_WritePin(BUZZER_GPIO_Port, BUZZER_Pin, GPIO_PIN_RESET);}


	if(LEFT_LAMP.Output){HAL_GPIO_WritePin(LEFT_LAMP_GPIO_Port, LEFT_LAMP_Pin, GPIO_PIN_SET);}
	else{HAL_GPIO_WritePin(LEFT_LAMP_GPIO_Port, LEFT_LAMP_Pin, GPIO_PIN_RESET);}

	if(RIGHT_LAMP.Output){HAL_GPIO_WritePin(RIGHT_LAMP_GPIO_Port, RIGHT_LAMP_Pin, GPIO_PIN_SET);}
	else{HAL_GPIO_WritePin(RIGHT_LAMP_GPIO_Port, RIGHT_LAMP_Pin, GPIO_PIN_RESET);}

	if(EMG_LAMP.Output){HAL_GPIO_WritePin(EMG_LAMP_GPIO_Port, EMG_LAMP_Pin, GPIO_PIN_SET);}
	else{HAL_GPIO_WritePin(EMG_LAMP_GPIO_Port, EMG_LAMP_Pin, GPIO_PIN_RESET);}


}
//=============================================================================================
//=============================================================================================
void LeftLamp_Start(uint8_t idx,uint16_t ontime,uint16_t offtime)
{
	switch(idx){
		case lamp_off:
			LEFT_LAMP.Stat=lamp_off;
			LEFT_LAMP.Idx = 0;
			LEFT_LAMP.Tmr = 0;
			LEFT_LAMP.OnValue = 0;
			LEFT_LAMP.OffValue = 0;
			LEFT_LAMP.Output = 0;
			break;
		case lamp_on:
			LEFT_LAMP.Stat=lamp_off;
			LEFT_LAMP.Idx = 0;
			LEFT_LAMP.Tmr = 0;
			LEFT_LAMP.OnValue = 0;
			LEFT_LAMP.OffValue = 0;
			LEFT_LAMP.Output = 1;
			LEFT_LAMP.Stat=lamp_on;
			break;
		case blink_once:
			LEFT_LAMP.Stat=lamp_off;
			LEFT_LAMP.Idx = 0;
			LEFT_LAMP.Tmr = 0;
			LEFT_LAMP.OnValue = ontime;
			LEFT_LAMP.OffValue = 0;
			LEFT_LAMP.Output = 1;
			LEFT_LAMP.Stat=blink_once;
			break;
		case blink_continue:
			LEFT_LAMP.Stat=lamp_off;
			LEFT_LAMP.Idx = 0;
			LEFT_LAMP.Tmr = 0;
			LEFT_LAMP.OnValue = ontime;
			LEFT_LAMP.OffValue = offtime;
			LEFT_LAMP.Output = 1;
			LEFT_LAMP.Stat=blink_continue;
			break;

		default:break;
	}
}
//============================================
void RightLamp_Start(uint8_t idx,uint16_t ontime,uint16_t offtime)
{
	switch(idx){
		case lamp_off:
			RIGHT_LAMP.Stat=lamp_off;
			RIGHT_LAMP.Idx = 0;
			RIGHT_LAMP.Tmr = 0;
			RIGHT_LAMP.OnValue = 0;
			RIGHT_LAMP.OffValue = 0;
			RIGHT_LAMP.Output = 0;
			break;
		case lamp_on:
			RIGHT_LAMP.Stat=lamp_off;
			RIGHT_LAMP.Idx = 0;
			RIGHT_LAMP.Tmr = 0;
			RIGHT_LAMP.OnValue = 0;
			RIGHT_LAMP.OffValue = 0;
			RIGHT_LAMP.Output = 1;
			RIGHT_LAMP.Stat=lamp_on;
			break;
		case blink_once:
			RIGHT_LAMP.Stat=lamp_off;
			RIGHT_LAMP.Idx = 0;
			RIGHT_LAMP.Tmr = 0;
			RIGHT_LAMP.OnValue = ontime;
			RIGHT_LAMP.OffValue = 0;
			RIGHT_LAMP.Output = 1;
			RIGHT_LAMP.Stat=blink_once;
			break;
		case blink_continue:
			RIGHT_LAMP.Stat=lamp_off;
			RIGHT_LAMP.Idx = 0;
			RIGHT_LAMP.Tmr = 0;
			RIGHT_LAMP.OnValue = ontime;
			RIGHT_LAMP.OffValue = offtime;
			RIGHT_LAMP.Output = 1;
			RIGHT_LAMP.Stat=blink_continue;
			break;

		default:break;
	}
}
//============================================
void EmgLamp_Start(uint8_t idx,uint16_t ontime,uint16_t offtime)
{
	switch(idx){
		case lamp_off:
			EMG_LAMP.Stat=lamp_off;
			EMG_LAMP.Idx = 0;
			EMG_LAMP.Tmr = 0;
			EMG_LAMP.OnValue = 0;
			EMG_LAMP.OffValue = 0;
			EMG_LAMP.Output = 0;
			break;
		case lamp_on:
			EMG_LAMP.Stat=lamp_off;
			EMG_LAMP.Idx = 0;
			EMG_LAMP.Tmr = 0;
			EMG_LAMP.OnValue = 0;
			EMG_LAMP.OffValue = 0;
			EMG_LAMP.Output = 1;
			EMG_LAMP.Stat=lamp_on;
			break;
		case blink_once:
			EMG_LAMP.Stat=lamp_off;
			EMG_LAMP.Idx = 0;
			EMG_LAMP.Tmr = 0;
			EMG_LAMP.OnValue = ontime;
			EMG_LAMP.OffValue = 0;
			EMG_LAMP.Output = 1;
			EMG_LAMP.Stat=blink_once;
			break;
		case blink_continue:
			EMG_LAMP.Stat=lamp_off;
			EMG_LAMP.Idx = 0;
			EMG_LAMP.Tmr = 0;
			EMG_LAMP.OnValue = ontime;
			EMG_LAMP.OffValue = offtime;
			EMG_LAMP.Output = 1;
			EMG_LAMP.Stat=blink_continue;
			break;

		default:break;
	}
}
//============================================
void LampBlinkCheck(void)
{
	//---------------
	if(LEFT_LAMP.Stat==blink_once){
		if(++LEFT_LAMP.Tmr >= LEFT_LAMP.OnValue){
			LEFT_LAMP.Tmr = 0;
			LEFT_LAMP.Output = 0;
			LEFT_LAMP.Stat=lamp_off;
		}
	}
	else if(LEFT_LAMP.Stat==blink_continue){
		if(LEFT_LAMP.Idx==0){
			if(++LEFT_LAMP.Tmr >= LEFT_LAMP.OnValue){
				LEFT_LAMP.Tmr = 0;
				if(LEFT_LAMP.Output){LEFT_LAMP.Output=0;}
				else{LEFT_LAMP.Output = 1;}
				LEFT_LAMP.Idx = 1;
			}
		}
		else if(LEFT_LAMP.Idx==1){
			if(++LEFT_LAMP.Tmr >= LEFT_LAMP.OffValue){
				LEFT_LAMP.Tmr = 0;
				if(LEFT_LAMP.Output){LEFT_LAMP.Output=0;}
				else{LEFT_LAMP.Output = 1;}
				LEFT_LAMP.Idx = 0;
			}
		}
	}
	//---------------
	//---------------
		if(RIGHT_LAMP.Stat==blink_once){
			if(++RIGHT_LAMP.Tmr >= RIGHT_LAMP.OnValue){
				RIGHT_LAMP.Tmr = 0;
				RIGHT_LAMP.Output = 0;
				RIGHT_LAMP.Stat=lamp_off;
			}
		}
		else if(RIGHT_LAMP.Stat==blink_continue){
			if(RIGHT_LAMP.Idx==0){
				if(++RIGHT_LAMP.Tmr >= RIGHT_LAMP.OnValue){
					RIGHT_LAMP.Tmr = 0;
					if(RIGHT_LAMP.Output){RIGHT_LAMP.Output=0;}
					else{RIGHT_LAMP.Output = 1;}
					RIGHT_LAMP.Idx = 1;
				}
			}
			else if(RIGHT_LAMP.Idx==1){
				if(++RIGHT_LAMP.Tmr >= RIGHT_LAMP.OffValue){
					RIGHT_LAMP.Tmr = 0;
					if(RIGHT_LAMP.Output){RIGHT_LAMP.Output=0;}
					else{RIGHT_LAMP.Output = 1;}
					RIGHT_LAMP.Idx = 0;
				}
			}
		}
		//---------------
		//---------------
		if(EMG_LAMP.Stat==blink_once){
			if(++EMG_LAMP.Tmr >= EMG_LAMP.OnValue){
				EMG_LAMP.Tmr = 0;
				EMG_LAMP.Output = 0;
				EMG_LAMP.Stat=lamp_off;
			}
		}
		else if(EMG_LAMP.Stat==blink_continue){
			if(EMG_LAMP.Idx==0){
				if(++EMG_LAMP.Tmr >= EMG_LAMP.OnValue){
					EMG_LAMP.Tmr = 0;
					if(EMG_LAMP.Output){EMG_LAMP.Output=0;}
					else{EMG_LAMP.Output = 1;}
					EMG_LAMP.Idx = 1;
				}
			}
			else if(EMG_LAMP.Idx==1){
				if(++EMG_LAMP.Tmr >= EMG_LAMP.OffValue){
					EMG_LAMP.Tmr = 0;
					if(EMG_LAMP.Output){EMG_LAMP.Output=0;}
					else{EMG_LAMP.Output = 1;}
					EMG_LAMP.Idx = 0;
				}
			}
		}
		//---------------

}
//=============================================================================================
//=============================================================================================
void ResetBeepValue(void)
{
	BUZZ.Output = 0;
	BUZZ.Stat = 0;
	BUZZ.Tmr = 0;
	BUZZ.Idx = beep_off;
}
//============================================
void Beep_Once(void)
{
	BUZZ.Output = 1;
	BUZZ.Idx = beep_off;
	BUZZ.Stat = 0;
	BUZZ.Tmr = 0;
	BUZZ.Idx = beep_once;
}
//============================================
void Beep_Pass(void)
{
	BUZZ.Output = 1;
	BUZZ.Idx = beep_off;
	BUZZ.Stat = 0;
	BUZZ.Tmr = 0;
	BUZZ.Idx = beep_pass;
}
//============================================
void Beep_Fail(void)
{
	BUZZ.Output = 1;
	BUZZ.Idx = beep_off;
	BUZZ.Stat = 0;
	BUZZ.Tmr = 0;
	BUZZ.Idx = beep_fail;
}
//============================================
void Beep_Emergency(void)
{
	BUZZ.Output = 1;
	BUZZ.Idx = beep_off;
	BUZZ.Stat = 0;
	BUZZ.Tmr = 0;
	BUZZ.Idx = beep_emergency;
}
//============================================


//==========================================================================================
//==========================================================================================
void BeepControl(void)
{

	switch(BUZZ.Idx){

		//--------------------
		case   beep_once:
			if(++BUZZ.Tmr>=BUZZ_ON_VALUE){
				BUZZ.Output = 0;
				BUZZ.Idx = beep_off;
			}
			break;
      //--------------------
      case   beep_pass:
         switch(BUZZ.Stat){
            case  0:
               if(++BUZZ.Tmr>=BUZZ_ON_VALUE){
            	   BUZZ.Output = 0;
                  BUZZ.Tmr = 0;
                  BUZZ.Stat++;
               }
               break;
            case  1:
               if(++BUZZ.Tmr>=BUZZ_OFF_VALUE){
            	   BUZZ.Output = 1;
                  BUZZ.Tmr = 0;
                  BUZZ.Stat++;
               }
               break;
            case  2:
               if(++BUZZ.Tmr>=BUZZ_ON_VALUE){
            	   BUZZ.Output = 0;
                  BUZZ.Idx = beep_off;
               }
               break;
            default:
            	BUZZ.Output = 0;
               BUZZ.Idx = beep_off;
               break;
         }
         break;
      //--------------------
      //--------------------
      case   beep_fail:
         switch(BUZZ.Stat){
            case  0:
               if(++BUZZ.Tmr>=BUZZ_ON_VALUE){
            	   BUZZ.Output = 0;
                  BUZZ.Tmr = 0;
                  BUZZ.Stat++;
               }
               break;
            case  1:
               if(++BUZZ.Tmr>=BUZZ_OFF_VALUE){
            	   BUZZ.Output = 1;
                  BUZZ.Tmr = 0;
                  BUZZ.Stat++;
               }
               break;
            case  2:
               if(++BUZZ.Tmr>=BUZZ_ON_VALUE){
            	   BUZZ.Output = 0;
                  BUZZ.Tmr = 0;
                  BUZZ.Stat++;
               }
               break;
            case  3:
               if(++BUZZ.Tmr>=BUZZ_OFF_VALUE){
            	   BUZZ.Output = 1;
                  BUZZ.Tmr = 0;
                  BUZZ.Stat++;
               }
               break;
            case  4:
               if(++BUZZ.Tmr>=300){
            	   BUZZ.Output = 0;
                  BUZZ.Idx = beep_off;
               }
               break;
            default:
            	BUZZ.Output = 0;
               BUZZ.Idx = beep_off;
               break;
         }
         break;
      //--------------------
      //--------------------
      case   beep_emergency:
         switch(BUZZ.Stat){
            case  0:
               if(++BUZZ.Tmr>=BUZZ_ON_VALUE){
            	   BUZZ.Output = 0;
                  BUZZ.Tmr = 0;
                  BUZZ.Stat++;
               }
               break;
            case  1:
               if(++BUZZ.Tmr>=BUZZ_OFF_VALUE){
            	   BUZZ.Output = 1;
                  BUZZ.Tmr = 0;
                  BUZZ.Stat++;
               }
               break;
            case  2:
               if(++BUZZ.Tmr>=BUZZ_ON_VALUE){
            	   BUZZ.Output = 0;
                  BUZZ.Tmr = 0;
                  BUZZ.Stat++;
               }
               break;
            case  3:
               if(++BUZZ.Tmr>=BUZZ_OFF_VALUE){
            	   BUZZ.Output = 1;
                  BUZZ.Tmr = 0;
                  BUZZ.Stat++;
               }
               break;
            case  4:
               if(++BUZZ.Tmr>=BUZZ_ON_VALUE){
            	   BUZZ.Output = 0;
                  BUZZ.Tmr = 0;
                  BUZZ.Stat++;
               }
               break;
            case  5:
               if(++BUZZ.Tmr>=BUZZ_OFF_VALUE){
            	   BUZZ.Output = 1;
                  BUZZ.Tmr = 0;
                  BUZZ.Stat++;
               }
               break;
            case  6:
               if(++BUZZ.Tmr>=BUZZ_EMG_ON_VALUE){
            	   BUZZ.Output = 0;
                  BUZZ.Idx = beep_off;
               }
               break;
            default:
            	BUZZ.Output = 0;
               BUZZ.Idx = beep_off;
               break;
         }
         break;
      //--------------------
      default:
    	  BUZZ.Output = 0;
         BUZZ.Idx = beep_off;
         break;
   }

}

//=============================================================================================
//=============================================================================================
void HAL_I2C_SlaveRxCpltCallback(I2C_HandleTypeDef *hi2c)
{
	if(hi2c->Instance == I2C1){
		I2C_1.RxQueue[I2C_1.RxHead] =  I2C_1.RcvTemp[0];
		if(++I2C_1.RxHead >= sizeof(I2C_1.RxQueue)){I2C_1.RxHead = 0;}
		I2C_1.Rcv_Flag=1;
	}

}

//=============================================================================================
//=============================================================================================
void HAL_UART_RxCpltCallback(UART_HandleTypeDef *huart)
{
	if(huart->Instance == USART1){
		U1.RxQueue[U1.RxHead] =  U1.RcvTemp[0];
		if(++U1.RxHead >= sizeof(U1.RxQueue)){U1.RxHead = 0;}
		HAL_UART_Receive_IT(&huart1, (uint8_t*)U1.RcvTemp, 1);
	}
	if(huart->Instance == USART2){
		U2.RxQueue[U2.RxHead] =  U2.RcvTemp[0];
		if(++U2.RxHead >= sizeof(U2.RxQueue)){U2.RxHead = 0;}
		HAL_UART_Receive_IT(&huart2, (uint8_t*)U2.RcvTemp, 1);
	}
	if(huart->Instance == USART3){
		U3.RxQueue[U3.RxHead] =  U3.RcvTemp[0];
		if(++U3.RxHead >= sizeof(U3.RxQueue)){U3.RxHead = 0;}
		HAL_UART_Receive_IT(&huart3, (uint8_t*)U3.RcvTemp, 1);
	}
}
//=============================================================================================
uint8_t U1_Get_Queue(void)
{

	uint8_t ret;
	ret = 0;

	if(U1.RxHead != U1.RxTail){
		U1.Rcv_Data = U1.RxQueue[U1.RxTail++];
		if(U1.RxTail >= sizeof(U1.RxQueue)){U1.RxTail = 0;}
		ret=1;
	}

	return(ret);
}
//=============================================================================================
uint8_t U2_Get_Queue(void)
{

	uint8_t ret;
	ret = 0;

	if(U2.RxHead != U2.RxTail){
		U2.Rcv_Data = U2.RxQueue[U2.RxTail++];
		if(U2.RxTail >= sizeof(U2.RxQueue)){U2.RxTail = 0;}
		ret=1;
	}

	return(ret);
}
//=============================================================================================
uint8_t U3_Get_Queue(void)
{

	uint8_t ret;
	ret = 0;

	if(U3.RxHead != U3.RxTail){
		U3.Rcv_Data = U3.RxQueue[U3.RxTail++];
		if(U3.RxTail >= sizeof(U3.RxQueue)){U3.RxTail = 0;}
		ret=1;
	}

	return(ret);
}
//=============================================================================================

uint8_t CHECK_NUM(uint8_t ch)
{
	if((ch>='0')&&(ch<='9')){return(1);}
	return(0);
}

/////////////////////////////////////////////////////////////////////////////////////////////

void RCV_WORK(void)
{

	static uint8_t i;


	//-------------------------------------------------------
	switch(U1.Ridx){
		case 0:
			for(i=0;i<sizeof(U1.RcvTemp);i++){U1.RcvTemp[i]=0;}
			U1.Rcv_Data=0;
			HAL_UART_Receive_IT(&huart1, (uint8_t*)U1.RcvTemp, 1);
			U1.Ridx++;
			break;
		case 1:
			U1.rcv_cnt=0;
			U1.Ridx=10;
			break;

		case 10:
			if(U1_Get_Queue()){
				if(U1.Rcv_Data==':'){
					memset(U1.RxString,(uint8_t)0,sizeof(U1.RxString));
					U1.RxString[U1.rcv_cnt++]=U1.Rcv_Data;
					Reset_Rcv1Timer(10);
					U1.Ridx++;
					break;
				}
				else if((U1.Rcv_Data!=CHAR_CR)&&(U1.Rcv_Data!=CHAR_LF)){
					memset(U1.RxString,(uint8_t)0,sizeof(U1.RxString));
					U1.RxString[U1.rcv_cnt++]=U1.Rcv_Data;
					Reset_Rcv1Timer(10);
					U1.Ridx=21;
					break;
				}
			}
			break;
		case 11:
			if(U1_Get_Queue()){
				Reset_Rcv1Timer(10);
				if(U1.rcv_cnt>MAX_STR_LENTH){U1.Ridx=0;break;}
				if((U1.Rcv_Data==CHAR_CR)||(U1.Rcv_Data==CHAR_LF)){
					U1.RxString[U1.rcv_cnt++]=0;
					U1.Ridx=16;
					break;
				}
				else{
					U1.RxString[U1.rcv_cnt++]=U1.Rcv_Data;
				}
			}
			if(U1.Rcv_OverTmr){
				U1.Ridx=0;
			}
			break;


		case 16:
			if(strncmp(U1.RxString,":FVER?",6)==0){
				U1.Ridx++;
			}
			else{
				//U1.Ridx=0;
				U1.Ridx=18;
			}
			break;

		case 17:
			U1.strnum = sprintf(U1.TxString,"(U1)%s",STR_UART_FILENAME);
			if(HAL_OK==HAL_UART_Transmit(&huart1,U1.TxString,(uint16_t)U1.strnum,(uint32_t)100)){
				U1.Ridx++;
			}
			break;
		case 18:
			U1.Rcv_Flag=1;
			Beep_Once();
			U1.Ridx=0;
			break;



		case 21:
			if(U1_Get_Queue()){
				Reset_Rcv1Timer(10);
				if(U1.rcv_cnt>MAX_STR_LENTH){U1.Ridx=0;break;}

				if(U1.Rcv_Data==CHAR_CR){U1.RxString[U1.rcv_cnt++]=1;}
				else if(U1.Rcv_Data==CHAR_LF){U1.RxString[U1.rcv_cnt++]=2;}
				else{U1.RxString[U1.rcv_cnt++]=U1.Rcv_Data;}
			}
			if(U1.Rcv_OverTmr){
				U1.Ridx++;
			}
			break;
		case 22:
			U1.Rcv_Flag=1;
			//Beep_Once();
			U1.Ridx=0;
			break;


		default:U1.Ridx=0;break;
	}
	//-------------------------------------------------------

	//-------------------------------------------------------
	switch(U2.Ridx){
		case 0:
			for(i=0;i<sizeof(U2.RcvTemp);i++){U2.RcvTemp[i]=0;}
			U2.Rcv_Data=0;
			HAL_UART_Receive_IT(&huart2, (uint8_t*)U2.RcvTemp, 1);
			U2.Ridx++;
			break;
		case 1:
			U2.rcv_cnt=0;
			U2.Ridx=10;
			break;

		case 10:
			if(U2_Get_Queue()){
				if(U2.Rcv_Data==':'){
					memset(U2.RxString,(uint8_t)0,sizeof(U2.RxString));
					U2.RxString[U2.rcv_cnt++]=U2.Rcv_Data;
					Reset_Rcv2Timer(10);
					U2.Ridx++;
					break;
				}
				else if((U2.Rcv_Data!=CHAR_CR)&&(U2.Rcv_Data!=CHAR_LF)){
					memset(U2.RxString,(uint8_t)0,sizeof(U2.RxString));
					U2.RxString[U2.rcv_cnt++]=U2.Rcv_Data;
					Reset_Rcv2Timer(10);
					U2.Ridx=21;
					break;
				}
				else if((U2.Rcv_Data=='T')||(U2.Rcv_Data=='S')){
					memset(U2.RxString,(uint8_t)0,sizeof(U2.RxString));
					U2.RxString[U2.rcv_cnt++]=U2.Rcv_Data;
					Reset_Rcv2Timer(10);
					U2.Ridx=21;
					break;
				}
			}
			break;
		case 11:
			if(U2_Get_Queue()){
				Reset_Rcv2Timer(10);
				if(U2.rcv_cnt>MAX_STR_LENTH){U2.Ridx=0;break;}
				if((U2.Rcv_Data==CHAR_CR)||(U2.Rcv_Data==CHAR_LF)){
					U2.RxString[U2.rcv_cnt++]=0;
					U2.Ridx=16;
					break;
				}
				else{
					U2.RxString[U2.rcv_cnt++]=U2.Rcv_Data;
				}
			}
			if(U2.Rcv_OverTmr){
				U2.Ridx=0;
			}
			break;


		case 16:
			if(strncmp(U2.RxString,":FVER?",6)==0){
				U2.Ridx++;
			}
			else{
				U2.Ridx=0;
			}
			break;

		case 17:
			U2.strnum = sprintf(U2.TxString,"(U2)%s",STR_UART_FILENAME);
			if(HAL_OK==HAL_UART_Transmit(&huart2,U2.TxString,(uint16_t)U2.strnum,(uint32_t)100)){
				U2.Ridx++;
			}
			break;
		case 18:
			U2.Rcv_Flag=1;
			Beep_Once();
			U2.Ridx=0;
			break;



		case 21:
			if(U2_Get_Queue()){
				Reset_Rcv2Timer(10);
				if(U2.rcv_cnt>MAX_STR_LENTH){U2.Ridx=0;break;}

				//if(U2.Rcv_Data==CHAR_CR){U2.RxString[U2.rcv_cnt++]=1;}
				//else if(U2.Rcv_Data==CHAR_LF){U2.RxString[U2.rcv_cnt++]=2;}
				if(U2.Rcv_Data==CHAR_LF){
					U2.RxString[U2.rcv_cnt++]=0;
					U2.Ridx++;
				}
				else{U2.RxString[U2.rcv_cnt++]=U2.Rcv_Data;}
			}
			if(U2.Rcv_OverTmr){
				//U2.Ridx++;
				U2.Ridx=0;
			}
			break;
		case 22:
			U2.Rcv_Flag=1;
			//Beep_Once();
			U2.Ridx=0;
			break;


		default:U2.Ridx=0;break;
	}
	//-------------------------------------------------------

	//-------------------------------------------------------
	switch(U3.Ridx){
		case 0:
			for(i=0;i<sizeof(U3.RcvTemp);i++){U3.RcvTemp[i]=0;}
			U3.Rcv_Data=0;
			HAL_UART_Receive_IT(&huart3, (uint8_t*)U3.RcvTemp, 1);
			U3.Ridx++;
			break;
		case 1:
			Reset_Rcv3Timer(10);
			U3.rcv_cnt=0;
			U3.Ridx=10;
			break;

		case 10:
			if(U3_Get_Queue()){
				if(U3.Rcv_Data==':'){
					memset(U3.RxString,(uint8_t)0,sizeof(U3.RxString));
					U3.RxString[U3.rcv_cnt++]=U3.Rcv_Data;
					Reset_Rcv3Timer(10);
					U3.Ridx++;
					break;
				}
				else if(U3.Rcv_Data=='r'){
					memset(U3.RxString,(uint8_t)0,sizeof(U3.RxString));
					U3.RxString[U3.rcv_cnt++]=U3.Rcv_Data;
					Reset_Rcv3Timer(10);
					U3.Ridx=41;
					break;
				}

			}
			if(U3.Rcv_OverTmr){
				U3.Ridx=0;
			}
			break;
		case 11:
			if(U3_Get_Queue()){
				Reset_Rcv3Timer(10);
				if(U3.rcv_cnt>MAX_STR_LENTH){U3.Ridx=0;break;}
				if((U3.Rcv_Data==CHAR_CR)||(U3.Rcv_Data==CHAR_LF)){
					U3.RxString[U3.rcv_cnt++]=0;
					U3.Ridx=16;
					break;
				}
				else{
					U3.RxString[U3.rcv_cnt++]=U3.Rcv_Data;
				}
			}
			if(U3.Rcv_OverTmr){
				U3.Ridx=0;
			}
			break;


		case 16:
			if(strncmp(U3.RxString,":FVER?",6)==0){
				U3.Ridx++;
			}
			else{
				U3.Ridx=0;
			}
			break;

		case 17:
			U3.strnum = sprintf(U3.TxString,"(U3)%s",STR_UART_FILENAME);
			if(HAL_OK==HAL_UART_Transmit(&huart3,U3.TxString,(uint16_t)U3.strnum,(uint32_t)100)){
				U3.Ridx++;
			}
			break;
		case 18:
			U3.Rcv_Flag=1;
			Beep_Once();
			U3.Ridx=0;
			break;


		case 41:
			if(U3_Get_Queue()){
				Reset_Rcv3Timer(10);
				if(U3.rcv_cnt>MAX_STR_LENTH){U3.Ridx=0;break;}

				if(U3.Rcv_Data=='>'){
					U3.RxString[U3.rcv_cnt++]=U3.Rcv_Data;
					U3.Ridx++;
					break;
				}
				U3.RxString[U3.rcv_cnt++]=U3.Rcv_Data;
			}
			if(U3.Rcv_OverTmr){
				U3.Ridx=0;
			}
			break;


		case 42:
			U3.Xycv_Rcv_Flag=1;
			U3.Ridx=0;
			break;



		default:U3.Ridx=0;break;
	}
	//-------------------------------------------------------





	return;
}



//=============================================================================================
//=============================================================================================


/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
